From d41d135c2fdbb9cf28f7a03ea05d23be4084d5e9 Mon Sep 17 00:00:00 2001
From: Ralph Bean <rbean@redhat.com>
Date: Mar 15 2016 13:33:24 +0000
Subject: [PATCH 324/1001] Merge #82 `Adds a bugzilla widget`


---

diff --git a/hubs/defaults.py b/hubs/defaults.py
index 3629062..c37b6cb 100644
--- a/hubs/defaults.py
+++ b/hubs/defaults.py
@@ -73,4 +73,10 @@ def add_user_widgets(session, hub, username, fullname):
             'display_number': 15,
         }))
     hub.widgets.append(widget)
+    widget = hubs.models.Widget(
+        plugin='bugzilla', index=8,
+        _config=json.dumps({
+            'username': username,
+        }))
+    hub.widgets.append(widget)
     return hub
diff --git a/hubs/widgets/__init__.py b/hubs/widgets/__init__.py
index 03084ac..cc7007c 100644
--- a/hubs/widgets/__init__.py
+++ b/hubs/widgets/__init__.py
@@ -14,6 +14,7 @@ from hubs.widgets import pagure_pr
 from hubs.widgets import github_pr
 from hubs.widgets import pagureissues
 from hubs.widgets import githubissues
+from hubs.widgets import bugzilla
 
 from hubs.widgets.workflow import pendingacls
 from hubs.widgets.workflow import updates2stable
@@ -37,6 +38,7 @@ registry = {
     'github_pr': github_pr,
     'pagureissues': pagureissues,
     'githubissues': githubissues,
+    'bugzilla': bugzilla,
 
     'workflow.pendingacls': pendingacls,
     'workflow.updates2stable': updates2stable,
diff --git a/hubs/widgets/bugzilla.py b/hubs/widgets/bugzilla.py
new file mode 100644
index 0000000..5482829
--- /dev/null
+++ b/hubs/widgets/bugzilla.py
@@ -0,0 +1,90 @@
+import requests
+import jinja2
+import pkgwat.api
+
+import hubs.validators as validators
+from hubs.widgets.base import argument
+from hubs.widgets.chrome import panel
+from hubs.hinting import hint, prefixed as _
+
+chrome = panel("Bugzilla: Issues")
+
+template = jinja2.Template("""
+<ul class="media-list">
+  {% for item in issues %}
+    <li class="media">
+      <div class="media-left">
+        <a href="https://bugzilla.redhat.com/show_bug.cgi?id=
+        {{ item['id'] }}" target="_blank">
+        <span class="label label-default">#{{ item['id'] }}</span>
+        </a>
+      </div>
+      <div class="media-body">
+        <h4 class="media-heading">
+          <a href="https://admin.fedoraproject.org/pkgdb/
+          package/rpms/{{ item['pkg_name'] }}" target=
+          "_blank">{{ item['pkg_name'] }}</a>:
+          {{ item['title'] }}
+        </h4>
+      </div>
+    </li>
+  {% endfor %}
+</ul>
+""")
+
+
+@argument(name="username",
+          default=None,
+          validator=validators.username,
+          help="A FAS username.")
+def data(session, widget, username):
+    pkgdb_url = "https://admin.fedoraproject.org/pkgdb/api/packager/package"
+    url = "/".join([pkgdb_url, username])
+    response = requests.get(url)
+    data = response.json()
+
+    issues = []
+
+    for package in data["point of contact"]:
+        if len(issues) == 3:
+            break
+        else:
+            pkg_details=pkgwat.api.bugs(package['name'])
+            for row in pkg_details['rows']:
+                if len(issues) == 3:
+                    break
+                else:
+                    issues.append(
+                        dict(
+                          id=row['id'],
+                          title=row['description'],
+                          pkg_name=package['name'],
+                          )
+                        )
+
+    for package in data["co-maintained"]:
+        if len(issues) == 3:
+            break
+        else:
+            pkg_details=pkgwat.api.bugs(package['name'])
+            for row in pkg_details['rows']:
+                if len(issues) == 3:
+                    break
+                else:
+                    issues.append(
+                        dict(
+                            id=row['id'],
+                            title=row['description'],
+                            pkg_name=package['name'],
+                            )
+                        )
+
+    return dict(
+      username=username,
+      issues=issues,
+    )
+
+
+@hint()
+def should_invalidate(message, session, widget):
+    raise NotImplementedError

